<template>
  <v-layout row wrap>
    <v-flex xs12>
      <v-text-field
              :id="'input-'+id"
              append-icon="close"
              @click:append="$emit('removeField', id)"
              :label="inputValueLabel"
              v-model="inputValue"
              v-if="inputValueAllowed">
      </v-text-field>
    </v-flex>
    <v-flex xs3>
      <v-select
              :id="'select-type-'+id"
              :items="typeAllowed"
              :disabled="inputFieldAllowed || !type"
              v-if="!inputValueAllowed"
              label="Type"
              @change="setType($event)"
      ></v-select>
    </v-flex>
    <v-flex xs9>
      <v-select
              :id="'select-fields-'+id"
              :disabled="!inputFieldAllowed && type"
              :items="fieldsAllowed"
              v-if="!inputValueAllowed"
              label="Field"
              @change="setField($event)"
              @change.once="$emit('addField')"
      ></v-select>
    </v-flex>
  </v-layout>
</template>

<script>
  export default {
    props:[
            'id', 'type'
    ],
    methods: {
      setType(event) {
        this.inputFieldAllowed = true;
        this.typeValue = event;
      },
      setField(event) {
        this.inputValueAllowed = true;
        this.fieldValue = event;
        if(!this.type){
          this.inputValueLabel = this.fieldValue+" = ";
        }else{
          this.inputValueLabel = this.typeValue+" "+this.fieldValue+" = ";
        }
      }
    },
    watch: {
      type: function(newVal, oldVal) { // watch it
        if(!newVal){
          this.inputValueLabel = this.fieldValue+" = ";
        }else{
          this.inputValueLabel = this.typeValue+" "+this.fieldValue+" = ";
        }
      }
    },
    data: () => ({
      inputValue : '',
      fieldValue: '',
      typeValue: '',
      inputValueLabel: '',
      inputFieldAllowed: false,
      inputValueAllowed: false,
      fieldsAllowed : [
          'name',
          'sign and/or symptoms',
          'is caused by'
      ],
      typeAllowed : ['OR', 'AND']
    })
  }
</script>
<style>
  .v-text-field__slot + .v-input__append-inner {
    color: green;
  }
  .v-text-field__slot + .v-input__append-inner > .v-input__icon v-input__icon--append > .theme--light.v-icon:hover{
    color: red !important;
    caret-color: red !important;
  }
</style>
